import router from './router'
import store from './store'
import { Message } from 'element-ui'
import NProgress from 'nprogress'
import 'nprogress/nprogress.css'
import { getToken } from '@/utils/auth'
import { judgmentNetworkReturnOutAddress } from "@/utils/ruoyi";

NProgress.configure({ showSpinner: false })

const whiteList = ['/login', '/auth-redirect', '/bind', '/register']

router.beforeEach((to, from, next) => {
  NProgress.start()
  if (getToken()) {
    to.meta.title && store.dispatch('settings/setTitle', to.meta.title)
    /* has token*/
    if (to.path === '/login') {
      next({ path: '/' })
      NProgress.done()
    }else {
      if (store.getters.roles.length === 0) {
        // 判断当前用户是否已拉取完user_info信息
        store.dispatch('GetInfo').then(() => {
          store.dispatch('GenerateRoutes').then(accessRoutes => {
            console.log('动态生成的路由表：', accessRoutes)
            // 根据roles权限生成可访问的路由表
            router.addRoutes(accessRoutes) // 动态添加可访问路由表
            next({ ...to, replace: true }) // hack方法 确保addRoutes已完成
          })
        }).catch(err => {
            store.dispatch('LogOut').then(() => {
              console.log('获取信息失败')
              Message.error(err)
              next({ path: '/' })
            })
          })
      } else {
        next()
      }
    }
  } else {
    if(to.path == '/codeHtml' || to.path === '/bigDataLogin' || to.path === '/androidFilePreview' || to.path === '/adminLogin' || to.path === '/supplierLogIn' ){
      next()
      return
    }
    // 没有token
    if (whiteList.indexOf(to.path) !== -1) {
      // 在免登录白名单，直接进入
      next()
    } else {
      if(process.env.VUE_APP_LOGIN_TYPE === 'skip'){
        window.location.href = judgmentNetworkReturnOutAddress();
      }else{
        router.replace({
          path: '/login'
        })
        NProgress.done()
      }
    }
  }
})

router.afterEach(() => {
  NProgress.done()
})
